﻿using Composite.Core.WebClient.Renderings.Data;
using Composite.Data;
using Composite.Data.Hierarchy;
using Composite.Data.Hierarchy.DataAncestorProviders;

namespace Sample.DataProvider.CultureData
{
    /// <summary>
    /// Our data interface - the schema for the data type we expose via this provider.
    /// You can read more about the properties on http://docs.composite.net in the Data/C# area.
    /// </summary>
    [DataScope("public")]
    [RelevantToUserType("Developer")]
    [KeyTemplatedXhtmlRenderer(XhtmlRenderingType.Embedable, "<span>{label}</span>")]
    [KeyPropertyName("Name")]
    [Title("Culture data")]
    [LabelPropertyName("DisplayName")]
    [ImmutableTypeId("{EEBBF421-E104-495A-8AC4-2746BDC1204F}")]
    [DataAncestorProvider(typeof(NoAncestorDataAncestorProvider))]
    public interface ICultureData : IData
    {
        [ImmutableFieldId("{D80673E5-BF3E-4488-BB7C-6C64C062E7BD}")]
        [StoreFieldType(PhysicalStoreFieldType.String, 8)]
        string Name { get; }

        [ImmutableFieldId("{4A060702-0659-45C0-800E-125E1826BFDF}")]
        [StoreFieldType(PhysicalStoreFieldType.String, 64)]
        string DisplayName { get; }

        [ImmutableFieldId("{5C546ED8-DEC1-4853-A892-A714AFBDC8DB}")]
        [StoreFieldType(PhysicalStoreFieldType.String, 64)]
        string EnglishName { get; }

        [ImmutableFieldId("{35624FF4-ABFF-45D3-8C18-B8FC246A03B4}")]
        [StoreFieldType(PhysicalStoreFieldType.Integer)]
        int LCID { get; }

        [ImmutableFieldId("{1E08DE8F-B670-490F-BED8-A3C94332EF3F}")]
        [StoreFieldType(PhysicalStoreFieldType.String, 3)]
        string ThreeLetterISOLanguageName { get; }
    }
}
